;
; application : MARIA VINCIT - revloving textured quasi-tetrahedron
; compiler    : FASM
; system      : MenuetOS
; author      : macgub
; email       : macgub3@wp.pl
; Fell free to use this intro in your own distribution of MenuetOS.
; I do some optimizations in tex_triangle procedure.

; Some adjustments made by Madis Kalme
; madis.kalme@mail.ee
; I tried optimizing it a bit, but don't know if it was successful. The objects
; can be:
; 1) Read from a file (*.3DS standard)
; 2) Written in manually (at the end of the code)
SIZE_X equ 300
SIZE_Y equ 300
TEX_X equ 128	  ; texture width
TEX_Y equ 128	  ;         height
TEX_SHIFT equ 7  ; texture widith shift const
TEX equ  SHIFTING ;  TEX={SHIFTING | FLUENTLY}
FLUENTLY = 0
SHIFTING = 1
TIMEOUT equ 4
ROUND equ 10
NON   =   0
MMX   =   1

Ext   =   MMX			;Ext={ NON | MMX}

use32
	org    0x0
	db     'MENUET01'	; 8 byte id
	dd     0x01		; header version
	dd     START		; start of code
	dd     I_END		; size of image
	dd     I_END		; memory for app
	dd     I_END		; esp
	dd     0x0 , 0x0	; I_Param , I_Icon

START:	  ; start of execution
	cld
	;call read_from_file
	call draw_window

still:
	mov	eax,23		; wait here for event with timeout
	mov	ebx,TIMEOUT
;        mov     eax,11
	int	0x40

	cmp	eax,1		; redraw request ?
	je	red
	cmp	eax,2		; key in buffer ?
	je	key
	cmp	eax,3		; button in buffer ?
	je	button

	jmp	noclose

    red:			; redraw
	call	draw_window
	jmp	noclose

    key:			; key
	mov	eax,2		; just read it and ignore
	int	0x40
	jmp	noclose

    button:			; button
	mov	eax,17		; get id
	int	0x40

	cmp	ah,1		; button id=1 ?
	jne	.ch_another

	mov	eax,-1		; close this program
	int	0x40
	.ch_another:
	cmp	ah,2
	jne	noclose
	inc	[r_flag]
	cmp	[r_flag],3
	jne	noclose
	mov	[r_flag],0
    noclose:

	call	calculate_angle ; calculates sinus and cosinus
	call	copy_points
	call	rotate_points
	call	translate_points; translate from 3d to 2d
	call	clrscr		; clear the screen
	call	sort_triangles

    RDTSC
    push eax

	call	draw_triangles	; draw all triangles from the list

    RDTSC
    sub eax,[esp]
    sub eax,41
    mov     ecx,10
  .dc:
    xor     edx,edx
    mov     edi,10
    div     edi
    add     dl,30h
    mov     [STRdata+ecx-1],dl
    loop    .dc
    pop eax

	mov	eax,7		; put image
	mov	ebx,screen
	mov	ecx,SIZE_X shl 16 + SIZE_Y
	mov	edx,5 shl 16 + 20
	int	0x40

    mov  eax,4			   ; function 4 : write text to window
    mov  ebx,5*65536+23 	   ; [x start] *65536 + [y start]
    mov  ecx,-1
    mov  edx,STRdata		   ; pointer to text beginning
    mov  esi,10 		   ; text length
    int  40h

	jmp	still

    sort_triangles:
	mov	esi,triangles
	mov	edi,triangles_with_z
	mov	ebp,points_rotated

    make_triangle_with_z:	;makes list with triangles and z position
	movzx	eax,word[esi]
	lea	eax,[eax*3]
	movzx	ecx,word[ebp+eax*2+4]

	movzx	eax,word[esi+2]
	lea	eax,[eax*3]
	add	cx,word[ebp+eax*2+4]

	movzx	eax,word[esi+4]
	lea	eax,[eax*3]
	add	cx,word[ebp+eax*2+4]

	mov	ax,cx
	cwd
	idiv	word[i3]
	movsd			; store vertex coordinates
	movsw
	stosw			; middle vertex coordinate  'z' in triangles_with_z list
	cmp	dword[esi],-1
	jne	make_triangle_with_z
	movsd			; copy end mark
	mov	eax,4
	lea	edx,[edi-8-trizdd]
	mov	[high],edx
	call	quicksort
	mov	eax,4
	mov	edx,[high]
	call	insertsort
	jmp	end_sort

    quicksort:
	mov	ecx,edx
	sub	ecx,eax
	cmp	ecx,32
	jc	.exit
	lea	ecx,[eax+edx]
	shr	ecx,4
	lea	ecx,[ecx*8-4]; i
	mov	ebx,[trizdd+eax]; trizdd[l]
	mov	esi,[trizdd+ecx]; trizdd[i]
	mov	edi,[trizdd+edx]; trizdd[h]
	cmp	ebx,esi
	jg	@f		; direction NB! you need to negate these to invert the order
      if Ext=NON
	mov	[trizdd+eax],esi
	mov	[trizdd+ecx],ebx
	mov	ebx,[trizdd+eax-4]
	mov	esi,[trizdd+ecx-4]
	mov	[trizdd+eax-4],esi
	mov	[trizdd+ecx-4],ebx
	mov	ebx,[trizdd+eax]
	mov	esi,[trizdd+ecx]
      else
	movq	mm0,[trizdq+eax-4]
	movq	mm1,[trizdq+ecx-4]
	movq	[trizdq+ecx-4],mm0
	movq	[trizdq+eax-4],mm1
	xchg	ebx,esi
      end if
      @@:
	cmp	ebx,edi
	jg	@f		; direction
      if Ext=NON
	mov	[trizdd+eax],edi
	mov	[trizdd+edx],ebx
	mov	ebx,[trizdd+eax-4]
	mov	edi,[trizdd+edx-4]
	mov	[trizdd+eax-4],edi
	mov	[trizdd+edx-4],ebx
	mov	ebx,[trizdd+eax]
	mov	edi,[trizdd+edx]
      else
	movq	mm0,[trizdq+eax-4]
	movq	mm1,[trizdq+edx-4]
	movq	[trizdq+edx-4],mm0
	movq	[trizdq+eax-4],mm1
	xchg	ebx,edi
      end if
      @@:
	cmp	esi,edi
	jg	@f		; direction
      if Ext=NON
	mov	[trizdd+ecx],edi
	mov	[trizdd+edx],esi
	mov	esi,[trizdd+ecx-4]
	mov	edi,[trizdd+edx-4]
	mov	[trizdd+ecx-4],edi
	mov	[trizdd+edx-4],esi
      else
	movq	mm0,[trizdq+ecx-4]
	movq	mm1,[trizdq+edx-4]
	movq	[trizdq+edx-4],mm0
	movq	[trizdq+ecx-4],mm1
;        xchg    ebx,esi
      end if
      @@:
	mov	ebp,eax 	; direction
	add	ebp,8	   ;   j
      if Ext=NON
	mov	esi,[trizdd+ebp]
	mov	edi,[trizdd+ecx]
	mov	[trizdd+ebp],edi
	mov	[trizdd+ecx],esi
	mov	esi,[trizdd+ebp-4]
	mov	edi,[trizdd+ecx-4]
	mov	[trizdd+ecx-4],esi
	mov	[trizdd+ebp-4],edi
      else
	movq	mm0,[trizdq+ebp-4]
	movq	mm1,[trizdq+ecx-4]
	movq	[trizdq+ecx-4],mm0
	movq	[trizdq+ebp-4],mm1
      end if
	mov	ecx,edx    ;   i; direction
	mov	ebx,[trizdd+ebp]; trizdd[j]
      .loop:
	sub	ecx,8		; direction
	cmp	[trizdd+ecx],ebx
	jl	.loop		; direction
      @@:
	add	ebp,8		; direction
	cmp	[trizdd+ebp],ebx
	jg	@b		; direction
	cmp	ebp,ecx
	jge	@f		; direction
      if Ext=NON
	mov	esi,[trizdd+ecx]
	mov	edi,[trizdd+ebp]
	mov	[trizdd+ebp],esi
	mov	[trizdd+ecx],edi
	mov	edi,[trizdd+ecx-4]
	mov	esi,[trizdd+ebp-4]
	mov	[trizdd+ebp-4],edi
	mov	[trizdd+ecx-4],esi
      else
	movq	mm0,[trizdq+ecx-4]
	movq	mm1,[trizdq+ebp-4]
	movq	[trizdq+ebp-4],mm0
	movq	[trizdq+ecx-4],mm1
      end if
	jmp	.loop
      @@:
      if Ext=NON
	mov	esi,[trizdd+ecx]
	mov	edi,[trizdd+eax+8]
	mov	[trizdd+eax+8],esi
	mov	[trizdd+ecx],edi
	mov	edi,[trizdd+ecx-4]
	mov	esi,[trizdd+eax+4]
	mov	[trizdd+eax+4],edi
	mov	[trizdd+ecx-4],esi
      else
	movq	mm0,[trizdq+ecx-4]
	movq	mm1,[trizdq+eax+4]; dir
	movq	[trizdq+eax+4],mm0; dir
	movq	[trizdq+ecx-4],mm1
      end if
	add	ecx,8
	push	ecx edx
	mov	edx,ebp
	call	quicksort
	pop	edx eax
	call	quicksort
      .exit:
    ret
    insertsort:
	mov	esi,eax
      .start:
	add	esi,8
	cmp	esi,edx
	ja	.exit
	mov	ebx,[trizdd+esi]
      if Ext=NON
	mov	ecx,[trizdd+esi-4]
      else
	movq	mm1,[trizdq+esi-4]
      end if
	mov	edi,esi
      @@:
	cmp	edi,eax
	jna	@f
	cmp	[trizdd+edi-8],ebx
	jg	@f		   ; direction
      if Ext=NON
	mov	ebp,[trizdd+edi-8]
	mov	[trizdd+edi],ebp
	mov	ebp,[trizdd+edi-12]
	mov	[trizdd+edi-4],ebp
      else
	movq	mm0,[trizdq+edi-12]
	movq	[trizdq+edi-4],mm0
      end if
	sub	edi,8
	jmp	@b
      @@:
      if Ext=NON
	mov	[trizdd+edi],ebx
	mov	[trizdd+edi-4],ecx
      else
	movq	[trizdq+edi-4],mm1
      end if
	jmp	.start
      .exit:
    ret
end_sort:

 ; translate triangles_with_z to sorted_triangles
	mov	esi,triangles_with_z
	mov	edi,sorted_triangles
    again_copy:
      if Ext=NON
	movsd
	movsw
	add	esi,2
      else
	movq	mm0,[esi]
	movq	[edi],mm0
	add	esi,8
	add	edi,6
      end if
	cmp	dword[esi],-1
	jne	again_copy
;      if Ext=MMX
;        emms
;      end if
	movsd  ; copy end mark too
	ret

    clrscr:
	mov	edi,screen
	mov	ecx,SIZE_X*SIZE_Y*3/4
	xor	eax,eax
      if Ext=NON
	rep	stosd
      else
	pxor	mm0,mm0
      @@:
	movq	[edi+00],mm0
	movq	[edi+08],mm0
	movq	[edi+16],mm0
	movq	[edi+24],mm0
	add	edi,32
	sub	ecx,8
	jnc	@b
      end if
	ret

    calculate_angle:
	fninit
;        fldpi
;        fidiv   [i180]
	fld	[piD180]
	fimul	[angle_counter]
	fsincos
	fstp	[sinbeta]
	fstp	[cosbeta]
	inc	[angle_counter]
	cmp	[angle_counter],360
	jne	end_calc_angle
	mov	[angle_counter],0
    end_calc_angle:
	ret

 rotate_points:
	fninit
	mov	ebx,points_rotated
    again_r:
	cmp	[r_flag],1
	je	.z_rot
	cmp	[r_flag],2
	je	.x_rot
    .y_rot:
	mov	eax,[ebx+2]	;z
	mov	ax,word[ebx]	;x
	sub	eax,dword[xo]
	mov	dword[xsub],eax
	fld	[sinbeta]
	fimul	[zsub]
	fchs
	fld	[cosbeta]
	fimul	[xsub]
	faddp
	fiadd	[xo]
	fistp	word[ebx]  ;x
	fld	[sinbeta]
	fimul	[xsub]
	fld	[cosbeta]
	fimul	[zsub]
	faddp
	fiadd	[zo]
	fistp	word[ebx+4] ;z
	jmp	.end_rot
   .z_rot:
	mov	ax,word[ebx]
	sub	ax,word[xo]	  ;need optimization
	mov	[xsub],ax
	mov	ax,word[ebx+2]
	sub	ax,word[yo]
	mov	[ysub],ax
	fld	[sinbeta]
	fimul	[ysub]
	fld	[cosbeta]
	fimul	[xsub]
	faddp
	fiadd	[xo]
	fistp	word[ebx]
	fld	[cosbeta]
	fimul	[ysub]
	fld	[sinbeta]
	fimul	[xsub]
	fchs
	faddp
	fiadd	[yo]
	fistp	word[ebx+2]
	jmp	.end_rot
   .x_rot:
	mov	ax,word[ebx+2]
	sub	ax,[yo]
	mov	[ysub],ax
	mov	ax,word[ebx+4]
	sub	ax,word[zo]
	mov	[zsub],ax
	fld	[sinbeta]
	fimul	[zsub]
	fld	[cosbeta]
	fimul	[ysub]
	faddp
	fiadd	[yo]
	fistp	word[ebx+2];y
	fld	[cosbeta]
	fimul	[zsub]
	fld	[sinbeta]
	fimul	[ysub]
	fchs
	faddp
	fiadd	[zo]
	fistp	word[ebx+4]
     .end_rot:
	add	ebx,6
	cmp	dword[ebx],-1
	jne	again_r
	ret
    draw_triangles:
	mov	ebp,points_rotated
;  mov esi,triangles
	mov	esi,sorted_triangles
    again_dts:
      if Ext=NON
	movzx	eax,word[esi]
	lea	eax,[eax*3]
	add	eax,eax
	push	ebp
	add	ebp,eax
	mov	eax,[ebp]
	mov	dword[xx1],eax
	mov	eax,[ebp+4]
	mov	[zz1],ax
	pop	ebp

	movzx	eax,word[esi+2]
	lea	eax,[eax*3]
	add	eax,eax
	push	ebp
	add	ebp,eax
	mov	eax,[ebp]
	mov	dword[xx2],eax
	mov	eax,[ebp+4]
	mov	[zz2],ax
	pop	ebp

	movzx	eax,word[esi+4]        ; xyz3 = [ebp+[esi+4]*6]
	lea	eax,[eax*3]
	add	eax,eax
	push	ebp
	add	ebp,eax
	mov	eax,[ebp]
	mov	dword[xx3],eax
	mov	eax,[ebp+4]
	mov	[zz3],ax
;        pop     ebp
;        push    ebp
	push	esi
      else
	movq	mm0,[esi]
	pmullw	mm0,qword[const6]
	movd	eax,mm0
	psrlq	mm0,16
	movd	ebx,mm0
	psrlq	mm0,16
	movd	ecx,mm0
	and	eax,0FFFFh
	and	ebx,0FFFFh
	and	ecx,0FFFFh
	movq	mm0,[ebp+eax]
	movq	mm1,[ebp+ebx]
	movq	mm2,[ebp+ecx]
	movq	qword[xx1],mm0
	movq	qword[xx2],mm1
	movq	qword[xx3],mm2
	push	ebp esi
;        emms
      end if

    macro set_red
    {
	inc	[tr_counter]
	cmp	[tr_counter],triangles_count+1
	jne	@f
	mov	[tr_counter],1
	mov	edx,0x00ff0000
    @@:
    }
;        mov     ax,[zz1]
;        add     ax,[zz2]
;        add     ax,[zz3]
;        cwd
;        idiv    [i3];    = ((a+b+c)/3+67)*2
;        add     ax,67
;        shl     ax,1
;        neg     al
;        xor     edx,edx
;        mov     ah,al           ;set color according to z position
;        shl     eax,8
;        mov     edx,eax
;        set_red
	mov	eax,dword[xx1]
	ror	eax,16
	mov	ebx,dword[xx2]
	ror	ebx,16
	mov	ecx,dword[xx3]
	ror	ecx,16

	mov	edi,screen
	mov	esi,texture
	push dword 127*65536+127
	push dword 127*65536+1
	push dword 1*65536+64
	call	tex_triangle
	pop	esi
	pop	ebp

	add	esi,6
	cmp	dword[esi],-1
	jne	again_dts
	ret

    translate_points:
	fninit
	mov	ebx,points_rotated
    again_trans:
	fild	word[ebx+4] ;z1
	fmul	[sq]
	fld	st
	fiadd	word[ebx]  ;x1
	fistp	word[ebx]
	fchs
	fiadd	word[ebx+2] ;y1
	fistp	word[ebx+2] ;y1

	add	ebx,6
	cmp	dword[ebx],-1
	jne	again_trans
	ret

    copy_points:
	mov	esi,points
	mov	edi,points_rotated
	mov	ecx,points_count*3+2
	rep	movsw
	ret
;---------------------------------------------------------------------
;--------------------textured triangle procedure----------------------
;---------------------------------------------------------------------
tex_triangle:
;----------in - eax - x1 shl 16 + y1
;-------------- ebx - x2 shl 16 + y2
;---------------ecx - x3 shl 16 + y3
;---------------edx - nothing
;---------------esi - pointer to texture buffer
;---------------edi - pointer to screen buffer
;-------------stack - texture coordinates
.tex_x1 equ  ebp+4
.tex_y1 equ  ebp+6
.tex_x2 equ  ebp+8
.tex_y2 equ  ebp+10
.tex_x3 equ  ebp+12
.tex_y3 equ  ebp+14

.x1 equ word [ebp-2]
.y1 equ word [ebp-4]
.x2 equ word [ebp-6]
.y2 equ word [ebp-8]
.x3 equ word [ebp-10]
.y3 equ word [ebp-12]

.dx12 equ dword [ebp-16]
.dx13 equ dword [ebp-20]
.dx23 equ dword [ebp-24]
.tex_dx12 equ dword [ebp-28]
.tex_dy12 equ dword [ebp-32]
.tex_dx13 equ dword [ebp-36]
.tex_dy13 equ dword [ebp-40]
.tex_dx23 equ dword [ebp-44]
.tex_dy23 equ dword [ebp-48]
.tex_ptr equ dword [ebp-52]
.scan_x1 equ dword [ebp-56]
.scan_y1 equ dword [ebp-60]
.scan_x2 equ dword [ebp-64]
.scan_y2 equ dword [ebp-68]
  mov ebp,esp
;  sub esp,68

  mov edx,dword[.tex_x1]		  ; check all parameters
  or dx,dx
  jl .tt_end
  cmp dx,TEX_X-1
  jg .tt_end
  shr edx,16
  or dx,dx
  jl .tt_end
  cmp dx,TEX_Y-1
  jg .tt_end

  mov edx,dword[.tex_x2]
  or dx,dx
  jl .tt_end
  cmp dx,TEX_X-1
  jg .tt_end
  shr edx,16
  or dx,dx
  jl .tt_end
  cmp dx,TEX_Y-1
  jg .tt_end

  mov edx,dword[.tex_x3]
  or dx,dx
  jl .tt_end
  cmp dx,TEX_X-1
  jg .tt_end
  shr edx,16
  cmp dx,TEX_Y-1
  jg .tt_end
  or dx,dx
  jl .tt_end

  mov edx,eax
  or edx,ebx
  or edx,ecx
  test edx,80008000h
  jne .tt_end

  cmp ax,SIZE_Y
  jg .tt_end
  ror eax,16
  cmp ax,SIZE_X
  jg .tt_end
  rol eax,16
  cmp bx,SIZE_Y
  jg .tt_end
  ror ebx,16
  cmp bx,SIZE_X
  jg .tt_end
  rol ebx,16
  cmp cx,SIZE_Y
  jg .tt_end
  ror ecx,16
  cmp cx,SIZE_X
  jg .tt_end
  rol ecx,16		       ; uff.. parameters was checked

  cmp ax,bx			    ;sort all parameters
  jle .tt_sort1
  xchg eax,ebx
  mov edx,dword [.tex_x1]
  xchg edx,dword [.tex_x2]
  mov dword[.tex_x1],edx
.tt_sort1:
  cmp ax,cx
  jle .tt_sort2
  xchg eax,ecx
  mov edx,dword [.tex_x1]
  xchg edx,dword [.tex_x3]
  mov dword [.tex_x1],edx
.tt_sort2:
  cmp bx,cx
  jle .tt_sort3
  xchg ebx,ecx
  mov edx,dword [.tex_x2]
  xchg edx,dword [.tex_x3]
  mov dword [.tex_x2],edx
.tt_sort3:
 ; mov .y1,ax     ; and store to user friendly variables
 ; shr eax,16
 ; mov .x1,ax
 ; mov .y2,bx
 ; shr ebx,16
 ; mov .x2,bx
 ; mov .y3,cx
 ; shr ecx,16
 ; mov .x3,cx
  push eax	     ; store in other way
  push ebx
  push ecx
  sub esp,56	    ; set corectly value of esp
  mov .tex_ptr,esi

  movsx ebx,.y2
  sub bx,.y1
  jnz .tt_dx12_make

  mov .dx12,0
  mov .tex_dx12,0
  mov .tex_dy12,0
  jmp .tt_dx12_done
.tt_dx12_make:
  mov ax,.x2
  sub ax,.x1
  cwde
  shl eax,ROUND
  cdq
  idiv ebx
  mov .dx12,eax 				    ; dx12 = (x2-x1)/(y2-y1)

  mov ax,word[.tex_x2]
  sub ax,word[.tex_x1]
  cwde
  shl eax,ROUND
  cdq
  idiv ebx
  mov .tex_dx12,eax			; tex_dx12 = (tex_x2-tex_x1)/(y2-y1)

  mov ax,word[.tex_y2]
  sub ax,word[.tex_y1]
  cwde
  shl eax,ROUND
  cdq
  idiv ebx
  mov .tex_dy12,eax			; tex_dy12 = (tex_y2-tex_y1)/(y2-y1)
.tt_dx12_done:

  movsx ebx,.y3
  sub bx,.y1
  jnz .tt_dx13_make

  mov .dx13,0
  mov .tex_dx13,0
  mov .tex_dy13,0
  jmp .tt_dx13_done
.tt_dx13_make:
  mov ax,.x3
  sub ax,.x1
  cwde
  shl eax,ROUND
  cdq
  idiv ebx
  mov .dx13,eax 				; dx13 = (x3-x1)/(y3-y1)

  mov ax,word[.tex_x3]
  sub ax,word[.tex_x1]
  cwde
  shl eax,ROUND
  cdq
  idiv ebx
  mov .tex_dx13,eax			  ; tex_dx13 = (tex_x3-tex_x1)/(y3-y1)

  mov ax,word[.tex_y3]
  sub ax,word[.tex_y1]
  cwde
  shl eax,ROUND
  cdq
  idiv ebx
  mov .tex_dy13,eax			  ; tex_dy13 = (tex_y3-tex_y1)/(y3-y1)
.tt_dx13_done:

  movsx ebx,.y3
  sub bx,.y2
  jnz .tt_dx23_make

  mov .dx23,0
  mov .tex_dx23,0
  mov .tex_dy23,0
  jmp .tt_dx23_done
.tt_dx23_make:
  mov ax,.x3
  sub ax,.x2
  cwde
  shl eax,ROUND
  cdq
  idiv ebx
  mov .dx23,eax 				; dx23 = (x3-x2)/(y3-y2)

  mov ax,word[.tex_x3]
  sub ax,word[.tex_x2]
  cwde
  shl eax,ROUND
  cdq
  idiv ebx
  mov .tex_dx23,eax		       ; tex_dx23 = (tex_x3-tex_x2)/(y3-y2)

  mov ax,word[.tex_y3]
  sub ax,word[.tex_y2]
  cwde
  shl eax,ROUND
  cdq
  idiv ebx
  mov .tex_dy23,eax		      ; tex_dy23 = (tex_y3-tex_y2)/(y3-y2)
.tt_dx23_done:

  movsx eax,.x1
  shl eax,ROUND
  mov ebx,eax

  movsx edx, word[.tex_x1]
  shl edx,ROUND
  mov .scan_x1,edx
  mov .scan_x2,edx
  movsx edx, word[.tex_y1]
  shl edx,ROUND
  mov .scan_y1,edx
  mov .scan_y2,edx

  mov cx,.y1
  cmp cx, .y2
  jge .tt_loop1_end
.tt_loop1:
  push edi
  push eax
  push ebx
  push cx
  push ebp

  mov edx, .scan_y2
  sar edx, ROUND
  push dx
  mov edx, .scan_x2
  sar edx, ROUND
  push dx
  mov edx, .scan_y1
  sar edx, ROUND
  push dx
  mov edx, .scan_x1
  sar edx, ROUND
  push dx
  push .tex_ptr

  push cx
  mov edx,ebx
  sar edx,ROUND
  push dx
  mov edx,eax
  sar edx,ROUND
  push dx
  call textured_line

  pop ebp
  pop cx
  pop ebx
  pop eax
  pop edi

  mov edx, .tex_dx13
  add .scan_x1, edx
  mov edx, .tex_dx12
  add .scan_x2, edx
  mov edx, .tex_dy13
  add .scan_y1, edx
  mov edx, .tex_dy12
  add .scan_y2, edx

  add eax, .dx13
  add ebx, .dx12
  inc cx
  cmp cx,.y2
  jl .tt_loop1
.tt_loop1_end:


  mov cx,.y2
  cmp cx, .y3
  jge .tt_loop2_end

  movsx ebx,.x2
  shl ebx,ROUND

  movsx edx, word[.tex_x2]
  shl edx,ROUND
  mov .scan_x2,edx
  movsx edx, word[.tex_y2]
  shl edx,ROUND
  mov .scan_y2,edx

.tt_loop2:
  push edi
  push eax
  push ebx
  push cx
  push ebp

  mov edx, .scan_y2
  sar edx, ROUND
  push dx
  mov edx, .scan_x2
  sar edx, ROUND
  push dx
  mov edx, .scan_y1
  sar edx, ROUND
  push dx
  mov edx, .scan_x1
  sar edx, ROUND
  push dx
  push .tex_ptr

  push cx
  mov edx,ebx
  sar edx,ROUND
  push dx
  mov edx,eax
  sar edx,ROUND
  push dx
  call textured_line

  pop ebp
  pop cx
  pop ebx
  pop eax
  pop edi

  mov edx, .tex_dx13
  add .scan_x1, edx
  mov edx, .tex_dx23
  add .scan_x2, edx
  mov edx, .tex_dy13
  add .scan_y1, edx
  mov edx, .tex_dy23
  add .scan_y2, edx

  add eax, .dx13
  add ebx, .dx23
  inc cx
  cmp cx,.y3
  jl .tt_loop2
.tt_loop2_end:

.tt_end:
 mov esp,ebp
ret 12

textured_line:
;-----in -edi screen buffer pointer
;------------ stack:
  .x1 equ word [ebp+4]
  .x2 equ word [ebp+6]
  .y  equ word [ebp+8]

  .tex_ptr equ dword [ebp+10]
  .tex_x1 equ word [ebp+14]
  .tex_y1 equ word [ebp+16]
  .tex_x2 equ word [ebp+18]
  .tex_y2 equ word [ebp+20]

  .tex_dx equ dword [ebp-4]
  .tex_dy equ dword [ebp-8]

  mov ebp,esp

;  mov ax,.y
;  or ax,ax
;  jl .tl_quit
;  cmp ax,SIZE_Y
;  jg .tl_quit

  mov ax,.x1
  cmp ax,.x2
  je .tl_quit
  jl .tl_ok

  xchg ax,.x2
  mov .x1,ax

  mov ax,.tex_x1
  xchg ax,.tex_x2
  mov .tex_x1,ax

  mov ax,.tex_y1
  xchg ax,.tex_y2
  mov .tex_y1,ax

 .tl_ok:
  mov ebx,edi
  movsx edi,.y
  mov eax,SIZE_X*3
  mul edi
  mov edi,eax
  movsx eax,.x1
  add edi,eax
  shl eax,1
  add edi,eax
  add edi,ebx

  mov cx,.x2
  sub cx,.x1
  movsx ecx,cx

  mov ax,.tex_x2
  sub ax,.tex_x1
  cwde
  shl eax,ROUND
  cdq
  idiv ecx
  push eax		       ; simplest way to mov [.tex_dx], eax
;  mov [.tex_dx],eax           ; tex_dx=(tex_x2-tex_x1)/(x2-x1)

  mov ax,.tex_y2
  sub ax,.tex_y1
  cwde
  shl eax,ROUND
  cdq
  idiv ecx
  push eax
 ; mov [.tex_dy],eax                  ; tex_dy = (tex_y2-tex_y1)/(x2-x1)

  movsx eax,.tex_x1
  shl eax,ROUND
  movsx ebx,.tex_y1
  shl ebx,ROUND
  cld
 .tl_loop:
  mov edx,eax
  mov esi,ebx
  sar edx,ROUND
  sar esi,ROUND
 macro .fluent
 {
  push eax
  push edx
  mov eax,TEX_X*3
  mul esi
  mov esi,eax
  pop edx
  pop eax
 }
 macro .shift
 {
  shl esi,TEX_SHIFT
  push edx
  mov edx,esi
  shl esi,1
  add esi,edx
  pop edx
 }
  if TEX = FLUENTLY
    .fluent
  end if
  if TEX = SHIFTING
    .shift
  end if
  add esi,edx
  shl edx,1
  add esi,edx
  add esi,.tex_ptr
  movsd
  dec edi
  add eax,.tex_dx
  add ebx,.tex_dy
  loop .tl_loop

 .tl_quit:
  mov esp,ebp
ret 18

;   *********************************************
;   *******  WINDOW DEFINITIONS AND DRAW ********
;   *********************************************
    draw_window:
	mov	eax,12		; function 12:tell os about windowdraw
	mov	ebx,1		; 1, start of draw
	int	0x40

	; DRAW WINDOW
	mov	eax,0		; function 0 : define and draw window
	mov	ebx,100*65536+SIZE_X+20 ; [x start] *65536 + [x size]
	mov	ecx,100*65536+SIZE_Y+30 ; [y start] *65536 + [y size]
	mov	edx,0x02000000	; color of work area RRGGBB,8->color gl
	mov	esi,0x805080d0	; color of grab bar  RRGGBB,8->color gl
	mov	edi,0x005080d0	; color of frames    RRGGBB
	int	0x40

	; WINDOW LABEL
	mov	eax,4		; function 4 : write text to window
	mov	ebx,8*65536+8	; [x start] *65536 + [y start]
	mov	ecx,0x20ddeeff	; font 1 & color ( 0xF0RRGGBB )
	mov	edx,labelt	; pointer to text beginning
	mov	esi,labellen-labelt	; text length
	int	0x40

	; CLOSE BUTTON
	mov	eax,8		; function 8 : define and draw button
	mov	ebx,(SIZE_X+20-19)*65536+12	; [x start] *65536 + [x size]
	mov	ecx,5*65536+12	; [y start] *65536 + [y size]
	mov	edx,1		; button id
	mov	esi,0x6688dd	; button color RRGGBB
	int	0x40
		 ; ROTARY BUTTON
    ;    mov     eax,8           ; function 8 : define and draw button
    ;    mov     ebx,(SIZE_X-19)*65536+12     ; [x start] *65536 + [x size]
    ;    mov     ecx,5*65536+12  ; [y start] *65536 + [y size]
    ;    mov     edx,2           ; button id
    ;    mov     esi,0x6688dd    ; button color RRGGBB
    ;    int     0x40

	mov	eax,12		; function 12:tell os about windowdraw
	mov	ebx,2		; 2, end of draw
	int	0x40

	ret


	; DATA AREA
	i3		dw	3
	sort_flag	db	0
	tr_counter	dw	0

	angle_counter dw 0
	piD180	dd 0.017453292519943295769236907684886
	sq	dd 0.70710678118654752440084436210485
	const6	dw 6,6,6,6
	xo	dw 150;130;87
	zo	dw 50
	yo	dw 150
	xoffset dd 130.0
	yoffset dd 100.0
	r_flag	db 0

    texture file '128x128.raw'
    labelt:
	db   'MARIA VINCIT'
      if Ext=MMX
	db   ' (MMX)'
      end if
    labellen:
	STRdata db '-1'
align 8
	@col	dd	?
	@y1	dw	?
	@x1	dw	?;+8
	@y2	dw	?
	@x2	dw	?
	@y3	dw	?
	@x3	dw	?;+16

	@dx12	dd	?
	@dx13	dd	?;+24
	@dx23	dd	?

	sinbeta dd	?;+32
	cosbeta dd	?

	xsub	dw	?
	zsub	dw	?;+40
	ysub	dw	?;

	xx1	dw	?
	yy1	dw	?
	zz1	dw	?;+48
	xx2	dw	?
	yy2	dw	?
	zz2	dw	?
	xx3	dw	?;+56
	yy3	dw	?
	zz3	dw	?

	high	dd	?
align 8
	buffer	dq	?

	err	dd	?
	drr	dd	?
	xx	dd	?
	yy	dd	?
	xst	dd	?
	yst	dd	?
align 16
	    points:
	    dw 100,200,0, 150,125,50, 200,200,0, 150,200,90

	points_count = ($-points)/6
dd -1 ;end marker
    triangles:
    dw 1,0,2, 1,3,0;, 1,2,3, 0,2,3
	triangles_count = ($-triangles)/6
dd -1  ; end marker

align 16
	points_rotated rw points_count*3 + 2
align 16
	label trizdd dword
	label trizdq qword
	triangles_with_z rw triangles_count*4 + 2 ; triangles triple dw + z position
align 16
	sorted_triangles rw triangles_count*3 + 2
align 16
	screen rb SIZE_X * SIZE_Y * 3	; screen buffer
	memStack rb 1000 ;memory area for stack
    I_END: